From 42420f43086cd7d35f0fcf218d847c2820ce22cc Mon Sep 17 00:00:00 2001
From: Stephen Gran <steve@lobefin.net>
Date: Thu, 24 Nov 2011 07:21:25 +0000
Subject: [PATCH] add new option to return socket errors as UNKNOWN

Signed-off-by: Stephen Gran <steve@lobefin.net>
---
 src/check_nrpe.c |   12 ++++++++++--
 1 files changed, 10 insertions(+), 2 deletions(-)

diff --git a/src/check_nrpe.c b/src/check_nrpe.c
index 03b136e..766188e 100644
--- a/src/check_nrpe.c
+++ b/src/check_nrpe.c
@@ -29,6 +29,7 @@ char *server_name=NULL;
 char *command_name=NULL;
 int socket_timeout=DEFAULT_SOCKET_TIMEOUT;
 int timeout_return_code=STATE_CRITICAL;
+int socket_error_return_code=STATE_CRITICAL;
 int sd;
 
 char query[MAX_INPUT_BUFFER]="";
@@ -88,7 +89,8 @@ int main(int argc, char **argv){
 		printf("\n");
 		printf("Options:\n");
 		printf(" -n         = Do no use SSL\n");
-		printf(" -u         = Make socket timeouts return an UNKNOWN state instead of CRITICAL\n");
+		printf(" -u         = Make command timeouts return an UNKNOWN state instead of CRITICAL\n");
+		printf(" -s         = Make socket errors return an UNKNOWN state instead of CRITICAL\n");
 		printf(" <host>     = The address of the host running the NRPE daemon\n");
 		printf(" [port]     = The port on which the daemon is running (default=%d)\n",DEFAULT_SERVER_PORT);
 		printf(" [timeout]  = Number of seconds before connection times out (default=%d)\n",DEFAULT_SOCKET_TIMEOUT);
@@ -144,6 +146,8 @@ int main(int argc, char **argv){
 
 	/* try to connect to the host at the given port number */
 	result=my_tcp_connect(server_name,server_port,&sd);
+	if (result==STATE_CRITICAL)
+		result=socket_error_return_code;
 
 #ifdef HAVE_SSL
 	/* do SSL handshake */
@@ -323,6 +327,7 @@ int process_arguments(int argc, char **argv){
 		{"command", required_argument, 0, 'c'},
 		{"args", required_argument, 0, 'a'},
 		{"no-ssl", no_argument, 0, 'n'},
+		{"socket-error-timeout", no_argument, 0, 's'},
 		{"unknown-timeout", no_argument, 0, 'u'},
 		{"timeout", required_argument, 0, 't'},
 		{"port", required_argument, 0, 'p'},
@@ -336,7 +341,7 @@ int process_arguments(int argc, char **argv){
 	if(argc<2)
 		return ERROR;
 
-	snprintf(optchars,MAX_INPUT_BUFFER,"H:c:a:t:p:nuhl");
+	snprintf(optchars,MAX_INPUT_BUFFER,"H:c:a:t:p:nsuhl");
 
 	while(1){
 #ifdef HAVE_GETOPT_LONG
@@ -382,6 +387,9 @@ int process_arguments(int argc, char **argv){
 		case 'n':
 			use_ssl=FALSE;
 			break;
+		case 's':
+			socket_error_return_code=STATE_UNKNOWN;
+			break;
 		case 'u':
 			timeout_return_code=STATE_UNKNOWN;
 			break;
-- 
1.7.2.5

